; Автор:	shilow@ukr.net
; Дата:
; Название:
; Версия:
; Имя файла:
; Для AVR:	ATTiny13A
; Тактовая частота: 9.6/8 МГц, внутренняя
; Выполняемые функции:
;

.listmac	; развернём макросы
;******************************
; инклуды
.nolist
.include "tn13Adef.inc"
.list

;******************************
; опредления
.def temp = r16		; рабочая переменная

.equ a = 0		; sample

;******************************
; ячейки в СОЗУ
.DSEG
;.ORG	SRAM_START
Sample:	.byte	30

;******************************
; константы в EEPROM
.ESEG
smpl1:	.DW	0x0000	; sample 1
smpl2:	.DB	0x05	; sample 2

;******************************
; память программ
.CSEG
.ORG 0

;******************************
; Таблица векторов прерываний
	rjmp	RESET		; Reset Handler
	rjmp	EXT_INT0	; IRQ0 Handler
	rjmp	PCINT		; PCINT0 Handler
	rjmp	TIM0_OVF	; Timer0 Overflow Handler
	rjmp	EE_RDY		; EEPROM Ready Handler
	rjmp	ANA_COMP	; Analog Comparator Handler
	rjmp	TIM0_COMPA	; Timer0 CompareA Handler
	rjmp	TIM0_COMPB	; Timer0 CompareB Handler
	rjmp	WATCHDOG	; Watchdog Interrupt Handler
	rjmp	ADCC		; ADC Conversion Handler

;******************************
;;;;; Первичная инициализация
RESET:	; Set Stack Pointer to top of RAM
	ldi	temp,low(RAMEND)
	out	SPL,temp
; выкл. аналог, компаратор
	ldi	temp,1<<ACD
	out	ACSR,temp
; Enable interrupts
	sei
;******************************
;;;;; Основная программа
BEGIN:
;;;;
	rjmp	BEGIN

;******************************
;;;;; Подпрограммы


;******************************
;;;;; Обработчики прерываний

; IRQ0 Handler
EXT_INT0:
	reti
; PCINT0 Handler
PCINT:
	reti
; Timer0 Overflow Handler
TIM0_OVF:
	reti
; EEPROM Ready Handler
EE_RDY:
	reti
; Analog Comparator Handler
ANA_COMP:
	reti
; Timer0 CompareA Handler
TIM0_COMPA:
	reti
; Timer0 CompareB Handler
TIM0_COMPB:
	reti
; Watchdog Interrupt Handler
WATCHDOG:
	reti
; ADC Conversion Handler
ADCC:
	reti

.exit
